
angular.module('beamng.apps')
.directive('steinCluster', [function () {
  return {
    templateUrl: '/ui/modules/apps/SteinCluster/app.html',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {


        /*var indLeft = loadImage("indicator_left.png");
        var indRight = loadImage("indicator_right.png");
        var lowBeam = loadImage("low_beams.png");
        var highBeam = loadImage("high_beams.png");
        var fuelIconOff = loadImage("fuel-icon-off.png");
        var fuelIconOn = loadImage("fuel-icon-on.png");
        var brakeIcon = loadImage("brake.png");*/

        function loadImage(url) {
            var img = new Image();
            img.src = "/ui/modules/apps/SteinCluster/" + url;
            return img;
        }

        var gearType = "automaticGearbox";

        var streams = ['electrics', 'engineInfo'];
        StreamsManager.add(streams);
        scope.$on('$destroy', function () {
            StreamsManager.remove(streams);
        });

        scope.currentTheme = {
            background: 'rgba(255, 255, 255, 0.9)',
            text: 'rgba(0, 0, 0, 0.9)',
            border: 'rgba(0, 0, 0, 0.9)',

            engIdle: 'rgba(160, 160, 255, 0.5)',
            engRedline: 'rgba(255, 0, 0, 0.5)',
            engNormal: 'rgba(0, 255, 0, 0.5)',
        };

        var c = element.find("canvas")[0];
        c.width = 180; 
        c.height = 70;
        var ctx = c.getContext('2d');
        ctx.imageSmoothingEnabled = false;

        var font = "ARLRDBD";

        var count = 0;
        var fuelConsumptionRate = 0;
        var avgFuelConsumptionRate = 0;
        var timer = 0;
        var avgTimer = 0;
        var prevTime = performance.now();
        var curTime = prevTime;
        var previousFuel = 0;

        function resetApp() {
            timer = 0;
            avgTimer = 0;
            count = 0;
            avgFuelConsumptionRate = 0;
            fuelConsumptionRate = 0;
            prevTime = performance.now();
            curTime = prevTime;
        }

        scope.reset = function ($event) {
            resetApp();
        }
        c.addEventListener("mousedown", function(e) {
            resetApp();
        });
        scope.$on('physicsStateChanged', function (event, data) {
            if (data) {
                curTime = performance.now();
            }
        });

        var sliderPos = 0;
        scope.$on('streamsUpdate', function (event, data) {
            
            ctx.font = "72px " + font;
            ctx.clearRect(0, 0, c.width, c.height);
            ctx.fillStyle = "rgba(0, 0, 0, 0.5)";
            ctx.fillRect(0, 0, c.width, c.height);

            if (data.electrics && data.engineInfo) {
                var wheelSpeed = data.electrics.wheelspeed;

                prevTime = curTime;

                curTime = performance.now();
                timer -= 0.001 * (curTime - prevTime);

                if (timer < 0) {
                    if (previousFuel > data.engineInfo[11]) {
                        fuelConsumptionRate = (previousFuel - data.engineInfo[11]) / ((0.5 - timer) * data.electrics.wheelspeed);
                    } else {
                        fuelConsumptionRate = 0;
                    }
                    previousFuel = data.engineInfo[11];
                    timer = 0.5;
                }

                avgTimer -= 0.001 * (curTime - prevTime);

                var cons = UiUnits.consumptionRate(fuelConsumptionRate);
                var mpg = Math.round(cons.val * 10) / 10;
                if(mpg > 99) mpg = 99;
                if(mpg == 0) mpg = 99;

                if (avgTimer < 0) {
                    if(!isNaN(mpg)) {
                        if(Math.round(data.engineInfo[4]) != 0) {
                            count++;
                            avgFuelConsumptionRate += (mpg - avgFuelConsumptionRate) / count;    
                        }
                    }
                    avgTimer = 1;
                }
                ctx.translate(0, -10);

                ctx.fillStyle = "white";
                ctx.textAlign = "center";
                ctx.textBaseline = "middler";
                ctx.textAlign = "left";
                ctx.font = "16px " + font;
                if(UiUnits.uiUnits.uiUnitConsumptionRate == "metric") {
                    ctx.fillText("Avg", 10, c.height / 2); 
                } else {
                    ctx.fillText("Average", 10, c.height / 2); 
                }
                ctx.textAlign = "right";

                ctx.font = "16px " + font;
                ctx.fillText(cons.unit, c.width - 10, c.height / 2);

                var w = ctx.measureText(cons.unit).width;
                ctx.font = "22px " + font;
                var avgMPG = Math.round(avgFuelConsumptionRate * 10) / 10;
                if(avgMPG > 99) avgMPG = 99;
                if(avgMPG == 0) avgMPG = 99;
                ctx.fillText(avgMPG.toFixed(1), c.width - 15 - w, c.height / 2);


                //BOTTOM BAR
                ctx.fillStyle = "rgba(0, 0, 0, 0.5)";
                ctx.fillRect(10, c.height / 2 + 15, (c.width - 20), 5);

                ctx.fillStyle = "rgb(91, 233, 249)";
                var mpgDisp = (c.width - 18) * (mpg / 75);
                if(mpgDisp > (c.width - 18)) mpgDisp = (c.width - 18);

                sliderPos = mpgDisp;
                /*if(sliderPos < mpgDisp) {
                    sliderPos += Math.abs(sliderPos - mpgDisp) / 5;
                } else {
                    sliderPos -= Math.abs(sliderPos - mpgDisp) / 5;
                }*/
                ctx.fillRect(10, c.height / 2 + 15, sliderPos, 5);
                ctx.fillStyle = "white";
                ctx.font = "16px " + font;
                ctx.fillRect(8, c.height / 2 + 20, (c.width - 16), 2);
                for(var i = 0; i < 4; i++) {
                    if(i == 0) {
                        ctx.textAlign = "left";
                    } else if(i == 3) {
                        ctx.textAlign = "right";
                    } else {
                        ctx.textAlign = "center";
                    }
                    ctx.fillText(i * 25, 8 + (i * (c.width - 16) / 3), c.height / 2 + 36);
                    ctx.fillRect(8 + (i * (c.width - 18) / 3), c.height / 2 + 15, 2, 5);
                }
                ctx.resetTransform();
            }


            //Odometer
            /*var odometer = scope.currentData.electrics.odometer;
            if(UiUnits.uiUnits.uiUnitLength == "imperial") {
                odometer = odometer * 0.000621371;
                ctx.textAlign = "right";
                ctx.fillStyle = "rgb(120, 120, 120)";
                ctx.fillText(pad(odometer.toFixed(1), 8) + " mi", 146, topY + 26);
                ctx.fillStyle = "rgb(255, 255, 255)";
                ctx.fillText(odometer.toFixed(1) + " mi", 146, topY + 26);
            } else {
                odometer = odometer * 0.001;
                ctx.textAlign = "right";
                ctx.fillStyle = "rgb(120, 120, 120)";
                ctx.fillText(pad(odometer.toFixed(1), 8) + " km", 153, topY + 26);
                ctx.fillStyle = "rgb(255, 255, 255)";
                ctx.fillText(odometer.toFixed(1) + " km", 153, topY + 26);
            }*/

        });
    
        scope.$on('VehicleReset', function (_, data) {
            resetApp();
        });

        scope.$on('VehicleFocusChanged', function (_, data) {
            resetApp();
        });


        function getWidth(txt) {
            return ctx.measureText(txt).width;
        }

        function pad( number, width ){
            width -= number.toString().length;
            if ( width > 0 ){
                return new Array( width + (/\./.test( number ) ? 2 : 1) ).join( '0' ) + number;
            }
            return number + ""; // always return a string
        }

        function getDefaultValue(type, defVal) {
            return localStorage.getItem("classicUI_" + type) || defVal;
        }
    }
  };
}]);
