
angular.module('beamng.apps')
.directive('steinDashOne', [function () {
  return {
    templateUrl: '/ui/modules/apps/SteinDashboard1/app.html',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {


        /*var indLeft = loadImage("indicator_left.png");
        var indRight = loadImage("indicator_right.png");
        var lowBeam = loadImage("low_beams.png");
        var highBeam = loadImage("high_beams.png");
        var fuelIconOff = loadImage("fuel-icon-off.png");
        var fuelIconOn = loadImage("fuel-icon-on.png");
        var brakeIcon = loadImage("brake.png");*/

        function loadImage(url) {
            var img = new Image();
            img.src = "/ui/modules/apps/SteinDashboard1/" + url;
            return img;
        }

        var gearType = "automaticGearbox";

        var streams = ['electrics', 'engineInfo'];
        StreamsManager.add(streams);
        scope.$on('$destroy', function () {
            StreamsManager.remove(streams);
        });
        scope.currentTheme = {
            background: 'rgba(255, 255, 255, 0.9)',
            text: 'rgba(0, 0, 0, 0.9)',
            border: 'rgba(0, 0, 0, 0.9)',

            engIdle: 'rgba(160, 160, 255, 0.5)',
            engRedline: 'rgba(255, 0, 0, 0.5)',
            engNormal: 'rgba(0, 255, 0, 0.5)',
        };

        var c = element.find("canvas")[0];
        c.width = 310; 
        c.height = 140;
        var ctx = c.getContext('2d');
        ctx.imageSmoothingEnabled = false;

        var font = "ARLRDBD";

        scope.$on('streamsUpdate', function (event, data) {
            scope.currentData = data;
            scope.rpmData = {
                value: Math.round(Number(data.engineInfo[4])),
                max: data.engineInfo[1],
                idle: data.engineInfo[0],
            };
            var mGear = data.engineInfo[5];
            var maxFGears = data.engineInfo[6];
            var maxRGears = data.engineInfo[7];

            ctx.font = "72px " + font;
            ctx.clearRect(0, 0, c.width, c.height);
            if(data.engineInfo[1] == 0) return;

            //ctx.fillStyle = "rgba(0, 0, 0, 0.2)";
            //ctx.fillRect(0, 0, c.width, c.height);

            ctx.fillStyle = "rgba(0, 0, 0, 0.5)";
            ctx.fillRect(0, 32, c.width, c.height - 32);
            ctx.fillRect(3, c.height - 32, c.width - 6, 29);

            var speed = Math.round(UiUnits.speed(scope.currentData.electrics.wheelspeed).val);
            if(speed > 999) speed = 999;
            ctx.fillStyle = "rgb(60, 60, 60)";
            ctx.textAlign = "right";
            //ctx.fillText(Math.round(UiUnits.speed(scope.currentData.electrics.wheelspeed).val) + " mph", 40, 40);
            ctx.fillText(pad(speed, 3), c.width - 10, c.height - 44);
            ctx.fillStyle = "white";
            ctx.fillText(speed, c.width - 10, c.height - 44);

            //Side Box
            ctx.fillStyle = "rgba(0, 0, 0, 0.2)";
            ctx.fillRect(3, 35, c.width - 150, c.height - 70);

            ctx.fillStyle = "white";
            ctx.font = "52px " + font;
            ctx.textAlign = "left";
            try {
                if(gearType == "manualGearbox") {
                    //get the sign of the current manual gear
                    var sign = mGear?mGear<0?-1:1:0;

                    //get the direction
                    if (sign == -1) {
                        if(mGear < 0 && maxRGears == 1) {
                            gearDirStr = "";
                        } else {
                            gearDirStr = "R";
                        }
                    } else if (sign == 1) {
                        gearDirStr = "F";
                    } else {
                        gearDirStr = "";
                    }

                    //get the gear number
                    if (mGear > 0) {
                        gearNumStr = Math.abs(mGear) + "/" + maxFGears;
                    } else if (mGear < 0 && maxRGears > 1) {
                        gearNumStr = Math.abs(mGear) + "/" + maxRGears;
                    } else if (mGear < 0 && maxRGears == 1) {
                        gearNumStr = "R";
                    } else {
                        gearNumStr = "N";
                    }
                    ctx.font = "32px " + font;

                } else if(gearType == "dctGearbox") {
                    gearNumStr = data.engineInfo[5];
                    gearDirStr = "";
                } else {
                    gearNumStr = data.electrics.gear;
                    gearDirStr = "";
                }
            } catch(e) {
                console.log(e);
                //error, fallback!
                gearNumStr = data.electrics.gear;
                gearDirStr = "";
            }
            ctx.fillText(gearNumStr, 10, gearType == "manualGearbox"?(c.height - 52):(c.height - 55));

            var trans = gearType=="manualGearbox"?"Manual":"Auto";
            trans = gearType=="dctGearbox"?"DCT":trans;
            trans = gearType=="electric"?"Electric":trans;
            ctx.fillStyle = "white";
            ctx.font = "20px " + font;
            ctx.textAlign = "left";
            if(trans == "Manual") ctx.fillText(trans, 10, c.height - 85);

            //fuel
            ctx.fillStyle = "rgba(255, 120, 50, 1)";
            ctx.fillRect(5, c.height - 42, 156 * scope.currentData.electrics.fuel, 5);

            var rgba = '';
            if(scope.rpmData.value < scope.rpmData.idle*1.25) {
                rgba = scope.currentTheme.engIdle;
            } else if(scope.rpmData.value > scope.rpmData.max*0.9) {
                rgba = scope.currentTheme.engRedline;
            } else {
                rgba = scope.currentTheme.engNormal;
            }
            

            ctx.fillStyle = rgba;
            ctx.fillRect(5,c.height - 30, Math.min(scope.rpmData.value / scope.rpmData.max * (c.width-10), c.width - 10), 25);

            ctx.font = "24px " + font;
            ctx.fillStyle = "white";
            ctx.textAlign = "left";
            ctx.fillText(scope.rpmData.idle, 8, c.height - 9);
            ctx.textAlign = "right";
            ctx.fillText(scope.rpmData.max, c.width - 6, c.height - 9);


            ctx.fillStyle = "rgba(0, 0, 0, 0.65)";
            var topX = 0;
            var topY = 0;
            ctx.fillRect(topX, topY, c.width, 32);
            
            ctx.font = "bold 22px " + font;
            ctx.fillStyle = "rgb(255, 255, 255)";
            ctx.textAlign = "right";
            ctx.fillText(UiUnits.speed().unit.toUpperCase(), c.width - 5, topY + 26);
            ctx.textAlign = "left";

            //separator for unit
            //ctx.fillStyle = "rgba(0, 0, 0, 0.4)";
            //ctx.fillRect(c.width - 12 - getWidth(UiUnits.speed().unit.toUpperCase()), topY + 6, 2, 24);

            /*var indX = c.width - 12 - getWidth(UiUnits.speed().unit.toUpperCase());
            if(scope.currentData.electrics.signal_L) {
                ctx.drawImage(indLeft, indX - 36*2, topY, 32, 32);
            }
            if(scope.currentData.electrics.signal_R) {
                ctx.drawImage(indRight, indX - 36, topY, 32, 32);
            }*/

            //parking brake
            ctx.fillStyle = "rgba(0, 0, 0, 0.4)";
            ctx.fillRect(topX, topY, c.width, 4);
            if(scope.currentData.electrics.parkingbrake) {
                ctx.fillStyle = "rgba(255, 78, 0, 1)";
                ctx.fillRect(topX, topY, c.width * scope.currentData.electrics.parkingbrake, 4);
            }

            if(scope.currentData.electrics.signal_L == 1) {
                ctx.fillStyle = "rgba(75, 200, 50, 1)";
                ctx.fillRect(topX, topY, c.width / 4, 4);
            }
            if(scope.currentData.electrics.signal_R == 1) {
                ctx.fillStyle = "rgba(75, 200, 50, 1)";
                ctx.fillRect(topX + (c.width / 4)*3, topY, c.width / 4, 4);
            }

            if(scope.currentData.electrics.lowbeam == 1) {
                ctx.fillStyle = "rgba(75, 200, 50, 1)";
                ctx.fillRect(topX + (c.width / 4), topY, c.width / 4, 4);
            }
            if(scope.currentData.electrics.highbeam == 1) {
                ctx.fillStyle = "rgba(75, 130, 255, 1)";
                ctx.fillRect(topX + (c.width / 4), topY, c.width / 4, 4);
            }

            //Odometer
            var odometer = scope.currentData.electrics.odometer;
            if(UiUnits.uiUnits.uiUnitLength == "imperial") {
                odometer = odometer * 0.000621371;
                ctx.textAlign = "right";
                ctx.fillStyle = "rgb(120, 120, 120)";
                ctx.fillText(pad(odometer.toFixed(1), 8) + " mi", 146, topY + 26);
                ctx.fillStyle = "rgb(255, 255, 255)";
                ctx.fillText(odometer.toFixed(1) + " mi", 146, topY + 26);
            } else {
                odometer = odometer * 0.001;
                ctx.textAlign = "right";
                ctx.fillStyle = "rgb(120, 120, 120)";
                ctx.fillText(pad(odometer.toFixed(1), 8) + " km", 153, topY + 26);
                ctx.fillStyle = "rgb(255, 255, 255)";
                ctx.fillText(odometer.toFixed(1) + " km", 153, topY + 26);
            }

        });
    
        scope.$on('VehicleReset', function (_, data) {
            scope.updateGearbox();
        });

        scope.$on('VehicleFocusChanged', function (_, data) {
            scope.updateGearbox();
        });

        scope.updateGearbox = function() {
            try {
                var exec = `powertrain.getDevice("gearbox")==null and "electric" or powertrain.getDevice("gearbox").type`;
                bngApi.activeObjectLua(exec, function(data) {
                    gearType = data;
                });
            } catch(e) {
                console.log("error");
            }
        };
        
        scope.updateGearbox();

        function getWidth(txt) {
            return ctx.measureText(txt).width;
        }

        function pad( number, width ){
            width -= number.toString().length;
            if ( width > 0 ){
                return new Array( width + (/\./.test( number ) ? 2 : 1) ).join( '0' ) + number;
            }
            return number + ""; // always return a string
        }

        function getDefaultValue(type, defVal) {
            return localStorage.getItem("classicUI_" + type) || defVal;
        }
    }
  };
}]);
